Attribute VB_Name = "DTSSample"
Option Explicit

'****************************************************************
'Microsoft SQL Server 2000
'Visual Basic file generated for DTS Package
'File Name: DTSArticle.bas
'Package Name: DTSArticle
'Package Description: Test Package for Article sample
'****************************************************************

Public goPackage As DTS.Package2

'Enumeration for the Connection Types...
Public Enum CNXTypes
    CNXSQLServer = 1
    CNXExcel = 2
End Enum

Private Sub Main()
    Set goPackage = New DTS.Package2

    With goPackage
        .Name = "DTSArticle2"
        .Description = "Description Here"
        .PackagePriorityClass = DTSPriorityClass_Normal
        .LineageOptions = DTSLineage_None
        .TransactionIsolationLevel = DTSIsoLevel_ReadUncommitted
        .RepositoryMetadataOptions = DTSReposMetadata_Default
        .LogServerFlags = DTSSQLStgFlag_Default
        .PackageType = DTSPkgType_Default
        .MaxConcurrentSteps = 4
        .WriteCompletionStatusToNTEventLog = False
        .FailOnError = False
        .UseTransaction = True
        .AutoCommitTransaction = True
        .LogToSQLServer = False
        .FailPackageOnLogFailure = False
        .ExplicitGlobalVariables = False
        .UseOLEDBServiceComponents = True
    End With

    Dim oConnection As DTS.Connection2

    Set oConnection = goPackage.Connections.New("SQLOLEDB.1")

    With oConnection
        'If we wanted to use Windows auth, set Integrated security and omit
        'User ID and Password, then set the UseTrustedConnection to true...
        '.ConnectionProperties("Integrated Security") = "SSPI"
        .ConnectionProperties("Persist Security Info") = True
        .ConnectionProperties("Application Name") = "My Custom VB App"
        .Name = "SQL Server Northwind CNX"
        .Description = "SQL Server Connection to Northwind"
        .DataSource = "LAMPKINLT"   'Change to your Server
        .UserID = "UserID"          'Change to a valid User ID
        .Password = "Password"      'Change to a valid Password
        .Catalog = "Northwind"
        .UseTrustedConnection = False
        .ID = CNXSQLServer
        .ConnectionTimeout = 60
        .Reusable = True
        .ConnectImmediate = False
        .UseDSL = False
    End With

    goPackage.Connections.Add oConnection
    Set oConnection = Nothing

    Set oConnection = goPackage.Connections.New("Microsoft.Jet.OLEDB.4.0")

    With oConnection
        .ConnectionProperties("Data Source") = "C:\DTSSample\NorthwindCustomers"    'Change as needed
        .ConnectionProperties("Extended Properties") = "Excel 8.0;HDR=YES;"
        .Name = "Microsoft Excel 97-2000"
        .Description = "Connection to our Export Excel file"
        .ID = CNXExcel
        .Reusable = True
        .ConnectImmediate = False
        .DataSource = "C:\DTSSample\NorthwindCustomers"                             'Change as needed
        .ConnectionTimeout = 60
        .UseTrustedConnection = False
    End With

    goPackage.Connections.Add oConnection
    Set oConnection = Nothing

    Call Task_Sub1(goPackage)

    Call CreateStep(goPackage)

    'Run the package...
    goPackage.Execute

    'See if we had any errors...
    tracePackageError goPackage

    'Free the objects...
    goPackage.UnInitialize

    Set goPackage = Nothing

    MsgBox "Finished!"
End Sub

Public Sub tracePackageError(oPackage As DTS.Package)
    Dim ErrorCode As Long
    Dim ErrorSource As String
    Dim ErrorDescription As String
    Dim ErrorHelpFile As String
    Dim ErrorHelpContext As Long
    Dim ErrorIDofInterfaceWithError As String
    Dim i As Integer

    For i = 1 To oPackage.Steps.Count
        If oPackage.Steps(i).ExecutionResult = DTSStepExecResult_Failure Then
            oPackage.Steps(i).GetExecutionErrorInfo ErrorCode, ErrorSource, ErrorDescription, _
                ErrorHelpFile, ErrorHelpContext, ErrorIDofInterfaceWithError
            MsgBox oPackage.Steps(i).Name & " failed" & vbCrLf & ErrorSource & vbCrLf & ErrorDescription
        End If
    Next i
End Sub

Public Sub CreateStep(ByVal goPackage As Object)
    Dim oStep As DTS.Step2
    Dim oPrecConstraint As DTS.PrecedenceConstraint

    Set oStep = goPackage.Steps.New

    With oStep
        .Name = "DTSStep_DTSDataPumpTask_1"
        .Description = "Transfer the Data Step"
        .ExecutionStatus = DTSStepExecStat_Waiting
        .TaskName = "DTSTask_DTSDataPumpTask_1"
        .RelativePriority = DTSStepRelativePriority_Normal
        .ScriptLanguage = "VBScript"
        .CommitSuccess = False
        .RollbackFailure = False
        .AddGlobalVariables = True
        .CloseConnection = True
        .ExecuteInMainThread = False
        .IsPackageDSORowset = False
        .JoinTransactionIfPresent = False
        .DisableStep = False
        .FailPackageOnError = False
    End With

    goPackage.Steps.Add oStep
    Set oStep = Nothing
End Sub

Public Sub Task_Sub1(ByVal goPackage As Object)
    Dim oTask As DTS.Task
    Dim oLookup As DTS.Lookup

    Dim oCustomTask1 As DTS.DataPumpTask2
    Set oTask = goPackage.Tasks.New("DTSDataPumpTask")
    oTask.Name = "DTSTask_DTSDataPumpTask_1"
    Set oCustomTask1 = oTask.CustomTask

    With oCustomTask1
        .Name = "DTSTask_DTSDataPumpTask_1"
        .Description = "Transfer the Data Task"
        .SourceConnectionID = CNXSQLServer
        .DestinationConnectionID = CNXExcel
        .SourceObjectName = "[Northwind].[dbo].[Customers]"
        .DestinationObjectName = "NWCustomers"
        .ProgressRowCount = 1000
        .MaximumErrorCount = 0
        .FetchBufferSize = 1
        .UseFastLoad = True
        .InsertCommitSize = 0
        .AllowIdentityInserts = False
        .FirstRow = "0"
        .LastRow = "0"
        .DataPumpOptions = 0
        .FastLoadOptions = DTSFastLoad_Default
        .ExceptionFileOptions = DTSExcepFile_SingleFile70
        .ExceptionFileColumnDelimiter = "|"
        .ExceptionFileRowDelimiter = vbCrLf
    End With

    Call oCustomTask1_Trans_Sub1(oCustomTask1)

    goPackage.Tasks.Add oTask

    Set oCustomTask1 = Nothing
    Set oTask = Nothing
End Sub

Public Sub oCustomTask1_Trans_Sub1(ByVal oCustomTask1 As Object)
    Dim oTransformation As DTS.Transformation2
    Dim oTransProps As DTS.Properties
    Dim oColumn As DTS.Column

    Set oTransformation = oCustomTask1.Transformations.New("DTSPump.DataPumpTransformScript")
        oTransformation.Name = "DTSTransformation__1"
        oTransformation.TransformFlags = DTSTransformFlag_Default
        oTransformation.ForceSourceBlobsBuffered = DTSForceMode_Default
        oTransformation.ForceBlobsInMemory = False
        oTransformation.InMemoryBlobSize = 1048576
        oTransformation.TransformPhases = 4

    Set oColumn = oTransformation.SourceColumns.New("Fax", 1)
        oColumn.Name = "Fax"
        oColumn.Ordinal = 1
        oColumn.Flags = 104
        oColumn.Size = 24
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("Phone", 2)
        oColumn.Name = "Phone"
        oColumn.Ordinal = 2
        oColumn.Flags = 104
        oColumn.Size = 24
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("Country", 3)
        oColumn.Name = "Country"
        oColumn.Ordinal = 3
        oColumn.Flags = 104
        oColumn.Size = 15
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("PostalCode", 4)
        oColumn.Name = "PostalCode"
        oColumn.Ordinal = 4
        oColumn.Flags = 104
        oColumn.Size = 10
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("Region", 5)
        oColumn.Name = "Region"
        oColumn.Ordinal = 5
        oColumn.Flags = 104
        oColumn.Size = 15
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("City", 6)
        oColumn.Name = "City"
        oColumn.Ordinal = 6
        oColumn.Flags = 104
        oColumn.Size = 15
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("Address", 7)
        oColumn.Name = "Address"
        oColumn.Ordinal = 7
        oColumn.Flags = 104
        oColumn.Size = 60
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("ContactTitle", 8)
        oColumn.Name = "ContactTitle"
        oColumn.Ordinal = 8
        oColumn.Flags = 104
        oColumn.Size = 30
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("ContactName", 9)
        oColumn.Name = "ContactName"
        oColumn.Ordinal = 9
        oColumn.Flags = 104
        oColumn.Size = 30
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("CompanyName", 10)
        oColumn.Name = "CompanyName"
        oColumn.Ordinal = 10
        oColumn.Flags = 8
        oColumn.Size = 40
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = False

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.SourceColumns.New("CustomerID", 11)
        oColumn.Name = "CustomerID"
        oColumn.Ordinal = 11
        oColumn.Flags = 24
        oColumn.Size = 5
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = False

    oTransformation.SourceColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("Fax", 1)
        oColumn.Name = "Fax"
        oColumn.Ordinal = 1
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("Phone", 2)
        oColumn.Name = "Phone"
        oColumn.Ordinal = 2
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("Location", 3)
        oColumn.Name = "Location"
        oColumn.Ordinal = 3
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("Address", 4)
        oColumn.Name = "Address"
        oColumn.Ordinal = 4
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("ContactTitle", 5)
        oColumn.Name = "ContactTitle"
        oColumn.Ordinal = 5
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("ContactName", 6)
        oColumn.Name = "ContactName"
        oColumn.Ordinal = 6
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("CompanyName", 7)
        oColumn.Name = "CompanyName"
        oColumn.Ordinal = 7
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oColumn = oTransformation.DestinationColumns.New("CustomerID", 8)
        oColumn.Name = "CustomerID"
        oColumn.Ordinal = 8
        oColumn.Flags = 102
        oColumn.Size = 255
        oColumn.DataType = 130
        oColumn.Precision = 0
        oColumn.NumericScale = 0
        oColumn.Nullable = True

    oTransformation.DestinationColumns.Add oColumn
    Set oColumn = Nothing

    Set oTransProps = oTransformation.TransformServerProperties

    oTransProps("Text") = "Function Main()" & vbCrLf & _
        "   Dim sTmpLocation, sTmpRegion" & vbCrLf & _
        "   'Put the City, Region, Country, and Zip into a string to combine" & vbCrLf & _
        "   'all of them into a single field for the output..." & vbCrLf & _
        "   sTmpLocation = Trim(DTSSource(""City""))" & vbCrLf & _
        "   sTmpRegion = Trim(DTSSource(""Region""))" & vbCrLf & _
        "   If Len(sTmpRegion) > 0 Then" & vbCrLf & _
        "           'Add the Region info..." & vbCrLf & _
        "           sTmpLocation = sTmpLocation + "", "" & sTmpRegion & ""  """ & vbCrLf & _
        "   Else" & vbCrLf & _
        "           'Or allow some space before the Country info..." & vbCrLf & _
        "           sTmpLocation = sTmpLocation & ""  """ & vbCrLf & _
        "   End If" & vbCrLf & _
        "   sTmpLocation = sTmpLocation & _" & vbCrLf & _
        "           ""("" & Trim(DTSSource(""Country"")) & "")  "" &_" & vbCrLf & _
        "           Trim(DTSSource(""PostalCode""))" & vbCrLf & vbCrLf
    oTransProps("Text") = oTransProps("Text") & _
        "   'All columns are copied, except for the City, Region, Country and Postal" & vbCrLf & _
        "   'Code fields are comined into a single field in the destination file..." & vbCrLf & _
        "   DTSDestination(""CustomerID"") = DTSSource(""CustomerID"")" & vbCrLf & _
        "   DTSDestination(""CompanyName"") = DTSSource(""CompanyName"")" & vbCrLf & _
        "   DTSDestination(""ContactName"") = DTSSource(""ContactName"")" & vbCrLf & _
        "   DTSDestination(""ContactTitle"") = DTSSource(""ContactTitle"")" & vbCrLf & _
        "   DTSDestination(""Address"") = DTSSource(""Address"")" & vbCrLf & _
        "   DTSDestination(""Location"") = sTmpLocation" & vbCrLf & _
        "   DTSDestination(""Phone"") = DTSSource(""Phone"")" & vbCrLf & _
        "   DTSDestination(""Fax"") = DTSSource(""Fax"")" & vbCrLf & _
        "   'We could add logic to determine if we want this script" & vbCrLf & _
        "   'to report an error, skip rows, or abort, etc. and set" & vbCrLf & _
        "   'Main to a different Transformation Status..." & vbCrLf & _
        "   Main = DTSTransformStat_OK" & vbCrLf & _
        "End Function"
    oTransProps("Language") = "VBScript"
    oTransProps("FunctionEntry") = "Main"

    Set oTransProps = Nothing

    oCustomTask1.Transformations.Add oTransformation
    Set oTransformation = Nothing
End Sub
